package com.streamsicle.util;

/**
 * Title:        Utils
 * Description:  Useful general stuff WOOO
 * Copyright:    Copyright (c) 2001
 * Company:      Streamsicle.com
 * @author
 * @version 1.0
 */

import java.util.*;

public class Utils {

   public Utils() {
   }

   public static String stripSpaces(String workit) {
      StringBuffer buff = new StringBuffer();
      for (int i=0; i<workit.length(); i++) {
         if (workit.charAt(i) != ' ')
            buff.append(workit.charAt(i));
      }
      return buff.toString();
   }

   public static String htmlSanitize(String workit) {
     StringBuffer buff = new StringBuffer();
     for (int i=0; i<workit.length(); i++) {
       switch(workit.charAt(i)) {
         case '\'': buff.append("%27");
           break;
         case '%': buff.append("%25");
           break;
         default:  buff.append(workit.charAt(i));
       }
     }
     return buff.toString();
   }

   /**
    * Replaces the values of the old properties with the new properties.
    */
   public static void replaceProperties (Properties oldProps,
					                     Properties newProps) {
      // Clear out the old properties
	  Enumeration keys = oldProps.keys();
	  while (keys.hasMoreElements()) {
		Object o = keys.nextElement();
		oldProps.remove(o);
	  }
	  // Add in new properties
	  keys = newProps.keys();
	  while (keys.hasMoreElements()) {
		Object o = keys.nextElement();
		oldProps.put(o, newProps.get(o));
	  }
   }
}