<%@ page import="java.util.*,com.streamsicle.*,com.streamsicle.util.*,java.util.Stack" %>
<%-- This page is meant to be included by main.jsp.  If it is included
     somewhere else, then the link for the directory names should be
     parameterized --%>
<%
   Integer updirID = (Integer)request.getAttribute(Constants.PARAM_UP_DIR);
   // String currdir = (String)request.getAttribute(Constants.PARAM_CURR_DIR);
   MP3File currdir = (MP3File) request.getAttribute(Constants.PARAM_CURR_DIR);

   String[] dirList = (String[])request.getAttribute("dirList");
   int[] dirIDList = (int[])request.getAttribute("dirIDList");

   String[] fileList = (String[])request.getAttribute("fileList");
   int[] fileIDList = (int[])request.getAttribute("fileIDList");

   Vector mp3FileList = (Vector)request.getAttribute(Constants.REQUEST_FILE_LIST);
   Vector mp3DirList = (Vector)request.getAttribute(Constants.REQUEST_DIR_LIST);

   // ID of the current dir
   String thisDir = session.getAttribute( Streamsicle.ATTRIB_DIR_ID ).toString();

   // Some length of display constants
   int kMAX_LIST_LENGTH = Integer.MAX_VALUE;
   int kMAX_HEADER_LENGTH = Integer.MAX_VALUE;

   String ctx = request.getContextPath()+"/";
   String imgPrefix = request.getContextPath()+"/look_default/";
%>

  <TABLE cellpadding="0" cellspacing="0" border="0" width="100%">
    <tr>
        <td colspan="3" class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=1 height=2 alt="" border="0"></td>
    </tr>
    <tr>
        <td class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=2 height=1 alt="" border="0"></td>
        <td class="content"><img src="<%=imgPrefix%>img/headers/hdr_songsavailable.gif" alt="" width="370" height="18" border="0" />
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
   <TR valign="top">
    <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
    <td class="content" colspan="5">
        <b>Browsing
        <%  // First put all the directories on a stack
            Stack dirs = new Stack();
            MP3File workdir = currdir;
            while (workdir != workdir.getParent()) {
                dirs.push(workdir);
                workdir = workdir.getParent();
            }
            dirs.push(workdir);
            // Next pull them off and display the links
            while (dirs.size() > 0) {
                MP3File dir = (MP3File) dirs.pop();
                String name = dir.getName();
                if ("".equals(name)) {
                    name = "Top";
                }
                %>/<a href="<%=ctx%>servlet/Streamsicle?dirID=<%=dir.getFileID()%>" class="actionTextsmall"><%=name%></a><%
            }
        %>
    </b><br><br>
	</td>
	</tr>


<%
	 for( int i = 0; i < mp3DirList.size(); i++ ) {
           String dirName = ((MP3File) mp3DirList.elementAt(i)).getName();
           int dirID = ((MP3File) mp3DirList.elementAt(i)).getFileID();
           if (dirName.length() > kMAX_LIST_LENGTH) {
            dirName = "..."+dirName.substring(dirName.length() - kMAX_LIST_LENGTH);
           }

%>
            <% if (((MP3File) mp3DirList.elementAt(i)).getIsARandomRoot()) { %>
            <tr>
            <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
            <td class="content" width="10">&nbsp;</td>
            <td class="content"><A HREF="#" onclick="javascript: dirId=<%=dirID%>; return !showPopup('dirPopup', event);" class="actionTextsmall"><img src="<%=imgPrefix%>img/icons/mini-nub.gif" align="center" border="0" alt="Play randomly from here"></A></td>
            <td class="content" width="1"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
		    <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
		    <td class="content" width="500">
                    <A title="<%=dirName%>" HREF="<%=ctx%>servlet/Streamsicle?dirID=<%=dirID%>" class="actionTextsmall"><%=dirName%></A><br>
 		    </td>
   	        </TR>
            <% } %>
<%
	 }
%>

<%
   if( mp3FileList.size() > 0 ) {
%>

	<TR valign="top">
		<td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
		<td class="content" colspan="5">
			<br>
			<strong>Choose a Song</strong> <A HREF="<%=ctx%>servlet/Streamsicle?action=playall&fileID=<%=thisDir%>" class="actionTextsmall">[Request All]</A><br><br></td>
	    </TR>
<%
	    for( int i = 0; i < mp3FileList.size(); i++ ) {
               String fileName = ((MP3File) mp3FileList.elementAt(i)).getName();
               int fileID = ((MP3File) mp3FileList.elementAt(i)).getFileID();
               if (fileName.length() > kMAX_LIST_LENGTH) {
                fileName = "..."+fileName.substring(fileName.length() - kMAX_LIST_LENGTH);
               }
               MP3File mp3 = (MP3File)mp3FileList.elementAt(i);
%>

    <TR>
		<td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
		<td class="content" width="10">&nbsp;</td>
        <td class="content" width="14"><a href="#" onclick="javascript: artistName='<%=Utils.htmlSanitize( Utils.stripSpaces(mp3.getArtist()) )%>'; id3FileId=<%=fileIDList[i]%>; return !showPopup('songRequestPopup', event);" class="actionTextsmall"><img src="<%=imgPrefix%>img/icons/mini-nub.gif" border="0" alt="Click for song info"></a></td>
        <td class="content" width="1"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
        <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
        <td class="content" width="500">
            <A title="<%=fileName%>" HREF="<%=ctx%>servlet/Streamsicle?action=add&song=<%=fileID%>" class="actionTextsmall"><%=fileName%></A>
            <%boolean showSongTimes = (application.getAttribute(Constants.SHOW_SONG_TIMES_ATTRIBUTE) != null);
            if((showSongTimes) && (mp3.getTimeLength().length() > 0)) { %>
                &nbsp;(<%=mp3.getTimeLength()%>)
            <% }%>
        </td>
	</TR>



<%
	 }
%>

<%
   }
%>
        <tr>
            <td class="content" colspan="6" height="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
        </tr>
   </TD>
   </TR>
   </table>
   </td>
   <td class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=2 height=1 alt="" border="0"></td>
   </tr>
    <tr>
        <td colspan="3" class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=1 height=2 alt="" border="0"></td>
    </tr>
</TABLE>
