<%@ page import="java.util.*,com.streamsicle.*,com.streamsicle.util.*" %>
<%
  String[] list = (String[])request.getAttribute("list");
  String[] listFilenames = (String[])request.getAttribute("listFilenames");
  Integer[] ids = (Integer[])request.getAttribute("ids");
  String[] dirList = (String[])request.getAttribute("dirList");
  Integer[] dirIDList = (Integer[])request.getAttribute("dirIDList");

  Vector mp3Files = (Vector)request.getAttribute(Constants.REQUEST_SEARCH_FILE_LIST);
  Vector mp3Dirs = (Vector)request.getAttribute(Constants.REQUEST_SEARCH_DIR_LIST);
  boolean hasSearched = true;
  if (mp3Files == null) {
      hasSearched = false;
  }
  if (mp3Dirs == null) {
      hasSearched = false;
  }

  String searchString = (String)session.getAttribute(Streamsicle.ATTRIB_SEARCH_STRING);
  if (searchString == null) {
      hasSearched = false;
  }

   // Some length of display constants
   int kMAX_LIST_LENGTH = Integer.MAX_VALUE;

   String ctx = request.getContextPath();
   String imgPrefix = request.getContextPath()+"/look_default/";
%>

  <TABLE cellpadding="0" cellspacing="0" border="0" width="100%">
    <tr>
        <td colspan="3" class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=1 height=2 alt="" border="0"></td>
    </tr>
    <tr>
        <td class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=2 height=1 alt="" border="0"></td>
        <td class="content"><img src="<%=imgPrefix%>img/headers/hdr_search.gif" alt="" width="370" height="18" border="0" />
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
<%-- CONTENT --%>
 <form action="<%=ctx%>/servlet/Streamsicle" method=get>
            <tr>
            <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
            <td class="content" width="10">&nbsp;</td>
            <td class="content" colspan="4">
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td align="middle"><input name="searchstring" type="text" size="50"></td>
<td align="middle"><input type="image" border="0" src="<%=imgPrefix%>/img/icons/search.gif" style="cursor: hand;"></td>
</tr>
</table>
            </td>
            </tr>
     <TR valign="top">
      <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
      <td class="content" colspan="5">
         <br>
         <%-- if no matches --%>
         <% if (!hasSearched || ((mp3Dirs.size() == 0) && (mp3Files.size() == 0) )) { %>
          <% if (hasSearched) { %>
          <b>No Matches</b>
          <% } %>
         <% } else { %>
         <b>Search results for <i><%=searchString%></i></b><br></td>
         <% } %>
     </TR>
<% if (hasSearched && (mp3Dirs.size() > 0)) { %>
     <TR valign="top">
      <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
      <td class="content" colspan="5">
         <br>
         <b><%= mp3Dirs.size() %></b> Folder<% if (mp3Dirs.size() > 1) {%>s<%}%> Found<br></td>
     </TR>

   <%
     for( int i = 0; i < mp3Dirs.size(); i++ ) {
            MP3File dir = (MP3File) mp3Dirs.elementAt(i);
            String dirName = dir.getName();
            int dirID = dir.getFileID();
            if (mp3Dirs.size() > kMAX_LIST_LENGTH) {
              dirName = "..."+dirName.substring(dirName.length() - kMAX_LIST_LENGTH);
            }

   %>
           <tr>
            <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
            <td class="content" width="10">&nbsp;</td>
            <td class="content" width="16"><A HREF="#" onclick="javascript: dirId=<%=dirID%>; return !showPopup('dirPopup', event);" class="actionTextsmall"><img src="<%=imgPrefix%>img/icons/mini-nub.gif" align="center" border="0" alt="Play randomly from here"></A></td>
            <td class="content" width="1"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
            <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
            <td class="content" width="500">
                <A title="<%=dirName%>" HREF="<%=ctx%>/servlet/Streamsicle?rightTab=requestTree&dirID=<%=dirID%>" class="actionTextsmall"><%=dirName%></A><br>
             </td>
           </TR>
    <%
	 }
    %>
<% } %>
<%-- =-=-=-=-=-=-=-=-=-=-=-=-= --%>

<% if (hasSearched && (mp3Files.size() > 0)) { %>

     <TR valign="top">
      <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
      <td class="content" colspan="5">
         <br>
         <b><%= mp3Files.size() %></b> Song<% if (mp3Files.size() > 1) {%>s<%}%> Found<br></td>
     </TR>

 <%
  for (int i = 0; i < mp3Files.size(); i++) {
    MP3File mp3 = (MP3File) mp3Files.elementAt(i);
    String fileName = mp3.getName();
    int fileID = mp3.getFileID();
    if (fileName.length() > kMAX_LIST_LENGTH) {
      fileName = "..." + fileName.substring(fileName.length() - kMAX_LIST_LENGTH);
    }

 %>

    <TR valign="top">
        <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
        <td class="content" width="10">&nbsp;</td>
        <td class="content" width="16"><a href="#" onclick="javascript: artistName='<%=Utils.htmlSanitize( Utils.stripSpaces(mp3.getArtist()) )%>'; id3FileId=<%=fileID%>; dirId=<%=mp3.getParent().getFileID()%>; return !showPopup('historyPopup', event);" class="actionTextsmall"><img src="<%=imgPrefix%>img/icons/mini-nub.gif" border="0" alt="Click for song info"></a></td>
        <td class="content" width="1"></td>
        <td class="content" width="6"><img src="<%=imgPrefix%>img/spacer.gif" width="1" height="1" border="0" alt=""></td>
        <td class="content" width="500" valign="bottom">
                                <A title="<%=fileName%>" HREF="<%=ctx%>/servlet/Streamsicle?action=add&song=<%=fileID%>" class="actionTextsmall"><%=fileName%></A>
                                <%boolean showSongTimes = (application.getAttribute(Constants.SHOW_SONG_TIMES_ATTRIBUTE) != null);
                                if(showSongTimes) { %>
                                &nbsp;(<%=mp3.getTimeLength()%>)
                                <% }%>
        </td>
    </TR>

<%--   <A title="<%= songName %>" HREF="<%=ctx%>/servlet/Streamsicle?action=add&song=<%= file.getFileID() %>" class="actionTextsmall"><%= songName %></A><br> --%>
 <%
  }
 %>
<%
  }
%>
	<tr>
   	<td class="content" colspan="6"><img src="<%=ctx%>/img/spacer.gif" width="1" height="1" border="0" alt=""></td>
   	</tr>
   </form>
   </table>
   </td>
   <td class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=2 height=1 alt="" border="0"></td>
   </tr>
    <tr>
        <td colspan="3" class="white"><img src="<%=imgPrefix%>img/spacer.gif" width=1 height=2 alt="" border="0"></td>
    </tr>
</TABLE>

